import os
import smtplib
from email.mime.base import MIMEBase
from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText
from email.utils import formatdate
from email import encoders
import logging
logger = logging.getLogger('Auto invoice')
global config

def get_smtp_info(cursor):
	sql = """SELECT emailname,smtphost as host,smtpport as port,emailusername as username,emailpassword as password,loginemail as is_auth,fromemail as from_email, smtp_secure as smtp_secure,noc_email as noc_email ,switch_alias FROM system_parameter LIMIT 1"""
	cursor.execute(sql)
	smtp_setting = cursor.fetchone()
	return smtp_setting

def _send_mail( send_from, invoice_cc, send_to, subject, text, files, server, port, username, password, smtp_info,isTls=False):
	#send_to = "piyali@intlcx.com;anne.denovolab@gmail.com;krasytod@gmail.com"
	msg = MIMEMultipart()
	send_to = send_to.replace(",", ";")
	invoice_cc = invoice_cc.replace(",", ";")
	msg['From'] = send_from
	msg['To'] = send_to  #COMMASPACE.join(send_to)
	msg['cc'] = invoice_cc
	msg['Date'] = formatdate(localtime = True)
	msg['Subject'] = subject
	msg.attach( MIMEText(text, 'html') )
	print("send to", send_to, "invoice cc", invoice_cc)
	if smtp_info.get('smtp_secure',smtp_info.get('secure'))  == 1:
		isTls=True
	else:
		isTls=False
	file_dir = config['other']['pdf_path']
	for f in files:
		#print ("f:",f)
		try:
			f = file_dir+"/"+f
			print(f)
		except Exception as e:
			logger.error (" Exception in generating file list for email:  %s" % (str(e) ) )
			print (" Exception in generating file list for email:  %s" % (str(e) ) )
			continue
		part = MIMEBase('application', "octet-stream")
		part.set_payload( open(f,"rb").read() )
		encoders.encode_base64(part)
		part.add_header('Content-Disposition', 'attachment; filename="{0}"'.format(os.path.basename(f)))
		msg.attach(part)
	try:
		send_to = send_to.split(";") + invoice_cc.split(";")
	except Exception as e:
		print("Exception send_to %s" % e)
		send_to = send_to.split(";")

	#print ("send_to 3",send_to, type(send_to))
	print ("smtp info",smtp_info.copy())
	#print ("msg: ",msg)

	try:
		if smtp_info.get('smtp_secure',smtp_info.get('secure'))  == 2:
			smtp = smtplib.SMTP_SSL()
			smtp.set_debuglevel(True)
			smtp.connect(server, port)
			#smtp = smtplib.SMTP(server, port)
		else:
			smtp = smtplib.SMTP()
			smtp.set_debuglevel(True)
			smtp.connect(server, port)

		if isTls: smtp.starttls()
		smtp.ehlo()
		smtp.login(smtp_info['username'], smtp_info['password'])
		#smtp.sendmail(smtp_info.get('from_email',smtp_info.get('email')), send_to, msg.as_string())
		smtp.sendmail(send_from, send_to, msg.as_string())
	except smtplib.SMTPRecipientsRefused:
		logger.error( 'All recipients were refused.')
		return -1
	except smtplib.SMTPHeloError:
		logger.error( 'The server didn’t reply properly to the HELO greeting.')
		return -1
	except smtplib.SMTPSenderRefused:
		logger.error( 'The server didn’t accept the %s.' % smtp_info['from_email'] )
		return -1
	except smtplib.SMTPDataError:
		logger.error( 'The server replied with an unexpected error code (other than a refusal of a recipient).' )
		return -1
	else:
		logger.debug( 'OK' )
		return 0

def sendto(send_to,cc):
	ret=[]
	if type(send_to)==type(''):
		send_to = send_to.replace(",", ";")
		ret = ret + send_to.split(';')
	if type(send_to) == type([]):
		ret = send_to
	if type(cc) == type(''):
		cc = cc.replace(",", ";")
		ret = ret + cc.split(';')
	if type(cc) == type([]):
		ret = ret + cc
	return [a for a in ret if a]

def send_mail(smtp_info, send_to, cc, subject, text, files):
	msg = MIMEMultipart()
	if 'name' in smtp_info and 'email' in smtp_info:
		send_from = '{name}<{email}>'.format_map(smtp_info)
	else:
		send_from = '{emailname}<{from_email}>'.format_map(smtp_info)
	msg['From'] = send_from
	msg['To'] = send_to.replace(';',',')+';'  # COMMASPACE.join(send_to)
	if cc:
		msg['Cc'] = cc.replace(';',',')+';'
	msg['Date'] = formatdate(localtime=True)
	msg['Subject'] = subject
	msg.attach(MIMEText(text, 'html'))

	for f in files:
		print("file attachments:", f)
		# f = f
		part = MIMEBase('application', "octet-stream")
		try:
			part.set_payload(open(f, "rb").read())
		except:
			logger.debug('file not exists on server {}'.format(f))
			part.set_payload(b'file not exists on server')
		encoders.encode_base64(part)
		part.add_header('Content-Disposition', 'attachment; filename="{0}"'.format(os.path.basename(f)))
		msg.attach(part)

	send_to = sendto(send_to, cc)
	ret_msg = ""
	server = smtp_info.get('smtp_host',smtp_info.get('host',None))
	port = smtp_info.get('smtp_port',smtp_info.get('port',None))
	isTls=(smtp_info.get('smtp_secure',smtp_info.get('secure',0)) == 1)

	if smtp_info.get('smtp_secure',smtp_info.get('secure'))  == 2:
		smtp = smtplib.SMTP_SSL(server, port)
	# smtp = smtplib.SMTP(server, port)
	else:
		smtp = smtplib.SMTP(server, port)
	try:
		smtp.set_debuglevel(True)
		if isTls: smtp.starttls()
		smtp.ehlo()
		smtp.login(smtp_info['username'], smtp_info['password'])
		#smtp.sendmail(smtp_info['from_email'], send_to, msg.as_string())
		smtp.sendmail(send_from, send_to, msg.as_string())
	except smtplib.SMTPRecipientsRefused:
		logger.error('All recipients were refused.')
		ret_msg = 'All recipients were refused.'
	except smtplib.SMTPHeloError:
		logger.error('The server didn’t reply properly to the HELO greeting.')
		ret_msg = 'The server didn’t reply properly to the HELO greeting.'
	except smtplib.SMTPSenderRefused:
		logger.error('The server didn’t accept the %s.' % smtp_info['from_email'])
		ret_msg = 'The server didn’t accept the %s.' % smtp_info['from_email']
	except smtplib.SMTPDataError:
		logger.error('The server replied with an unexpected error code (other than a refusal of a recipient).')
		ret_msg = 'The server replied with an unexpected error code (other than a refusal of a recipient).'
	else:
		logger.debug('OK')
		ret_msg = 'OK'
	finally:
		try:
			smtp.quit()
		except:
			pass
		return ret_msg


def send_email_log(client, send_to, mail_subject, mail_content, files, error=False, error_msg="", pg_cur1=None):
	pg_cur = None
	if pg_cur1 != None:
		pg_cur = pg_cur1
	if error == False:
		sql = """insert into email_log(send_time,client_id,email_addresses,files ,type,subject,content,status ) values (CURRENT_TIMESTAMP(0),%s, %s ,%s, %s,%s, %s,0)"""
		## email log still do not work!
		print("send_to ", send_to, "files ", files)
		print(sql)
		pg_cur.execute(sql, (client['client_id'], str(send_to), files, 7, mail_subject, mail_content))
	else:
		sql = """insert into email_log(send_time,client_id,email_addresses,files ,type,subject,content,status, error) values (CURRENT_TIMESTAMP(0),%s, %s ,%s, %s,%s, %s,1,%s)"""
		## email log still do not work!
		print("send_to ", send_to, "files ", files)
		print(sql)
		pg_cur.execute(sql, (client['client_id'], str(send_to), files, 7, mail_subject, mail_content, error_msg))
