from AutoInvoice import connect_to_postgresql, logger, GetClient, checkClients, INVOICE_SQL, INVOICE_COUNT_SQL, \
            makeClientDict,getCdrLink
from manualinvoice import email_invoice, get_smtp_info



class Test(object):

    def run(self):
        pg_cur = self.config_pg()
        #self.test_cdr_link(pg_cur)
        #self.test_check_clients(pg_cur,test_client_id = 59)
        self.test_check_clients(pg_cur,test_client_id = 82)
        #self.test_mail(pg_cur)

    def test_cdr_link(self, pg_cur,invoice_id = 55):
        # test cd_link
        client = {'client_id': '58'}

        data = {'start_date': '2020-07-01 00:00:00', 'end_date': '2020-07-31 23:59:59'}
        getCdrLink(client, pg_cur, invoice_id, data, fields=None)

    def test_check_clients(self, pg_cur,test_client_id = 62):
        # test checkClients
        import datetime
        pg_cur.execute(INVOICE_SQL + ' and client.client_id= {}'.format(test_client_id))
        result = pg_cur.fetchall()
        for row in result:
            print(row.get("client_id", "N/A"), row.get("days", "N/A"))
        pg_cur.execute("""select resource.client_id,count(resource.ingress is true) from resource join
    client on resource.client_id=client.client_id where resource.client_id= {} group by resource.client_id having
    count(resource.ingress is true) > 0;""".format(test_client_id))
        result_count = pg_cur.fetchall()
        # print ("result:", len (result) )
        # print ("result_count:", result_count)
        try:
            client_dict = makeClientDict(result_count)  # '14483': {'ingress_count': 2, 'client_id': 14483}
        except Exception as e:
            print("Error in makeClientDict %s" % e)
            logger.error("Error in makeClientDict %s" % e)
        print("client_dict:", client_dict)
        total_invoices = 0
        #today = datetime.datetime.now()
        today = datetime.datetime.strptime('2020-10-01',"%Y-%m-%d")
        total_invoices, invoices_needed = checkClients(result, client_dict, total_invoices, pg_cur, today)

    def config_pg(self):
        import configparser, argparse
        global config  # pidfile
        config = configparser.ConfigParser()
        config.read('config.ini')
        try:
            pg_conn, pg_cur = connect_to_postgresql(config["POSTGRES"]["hostaddr"], int(config["POSTGRES"]["port"]),
                                                    config["POSTGRES"]["dbname"], config["POSTGRES"]["user"],
                                                    config["POSTGRES"]["password"])  # config["POSTGRES"]["password"]
        except Exception as e:
            print(" Exception in connect_to_postgresql:  %s" % (str(e)))
            logger.error(" Exception in connect_to_postgresql:  %s" % (str(e)))
        print('ok')
        return pg_cur

    def test_mail(self, pg_cur):
        invoice_id = 55
        sql = """SELECT * FROM invoice where invoice_id={} """.format(invoice_id)
        pg_cur.execute(sql)
        tasks = pg_cur.fetchall()
        data = tasks[0]
        client = GetClient({'client_id': 58}, pg_cur)
        # data = {'start_date': client[1], 'end_date': client[2]}
        smtp_info = get_smtp_info(pg_cur)
        filename = '/opt/denovo/web/download/invoice/303202008071423.pdf'
        email_invoice(filename, client, data, smtp_info, resend=True, send_to='_novvv@mail.ru', invoice_number='61',
                      pg_cur1=pg_cur)


if __name__ == '__main__':
    t=Test()
    t.run()
